#calculate single-trait false discovery by effect direction 
require(data.table)
#dlist <- dlist
#k <- 3
#id <- 'SNP'
#chr <- 'Chr'
#bp <- 'bp'
#bpa <- 'b'
#sepa <- 'se'
#ppa <- 'p'
#pvec <- c(0.5,0.01,1e-3,1e-5,5e-8,1e-12)
#cau=T


edmesc <- function(dlist,k,id,chr,bp,bpa,sepa,ppa,pvec,cau){
 dg <- nchar(k)
 trbmlist <- list()
 trlist<- list()
 for (trnum in (sprintf(paste0('%0.',dg,'d'), 1:k)))
 {print(paste0('tr',trnum,' started at ',Sys.time()))
   bcdt <- merge(dlist[[1]][,c(which(colnames(dlist[[1]]) %in% id),grep(paste0('tr',trnum,'.',bpa,'|',trnum,'.',ppa),colnames(dlist[[1]]))),with=F],dlist[[2]][,c(which(colnames(dlist[[2]]) %in% id),grep(paste0('tr',trnum,'.',bpa,'|',trnum,'.',ppa),colnames(dlist[[2]]))),with=F],by=id,sort=F)
   colnames(bcdt) <- gsub(paste0('tr',trnum,'.'),'',colnames(bcdt))
   bcdt[,eval(parse(text=paste0('csd.tr',trnum,':=ifelse(b.x*b.y>0,1,0)')))]
   if (missing(cau)|cau==F)
   { cutlist <- list()
     for (cut in pvec)
     {print(paste0('doing p cut=',cut,' tr',trnum,' at ',Sys.time()))
     #test for reference population
     same.r <- bcdt[p.x<cut&b.x*b.y>0,.N]
     ti.r <- bcdt[p.x<cut,.N]
     t0.r <- 2*(ti.r-same.r)
     fdr.ed.r <- t0.r/ti.r
     fdr.r <- cut*(1- ti.r/bcdt[,.N]) / ((ti.r/bcdt[,.N])*(1-cut))
     #test for validaiton population
     same.v <- bcdt[p.y<cut&b.x*b.y>0,.N]
     ti.v <- bcdt[p.y<cut,.N]
     t0.v <- 2*(ti.v-same.v)
     fdr.ed.v <- t0.v/ti.v
     fdr.v <- cut*(1- ti.v/bcdt[,.N]) / ((ti.v/bcdt[,.N])*(1-cut))
     cutlist[[as.character(cut)]]<- as.numeric(c(trnum,cut,same.r,t0.r,ti.r,fdr.ed.r,fdr.r,same.v,t0.v,ti.v,fdr.ed.v,fdr.v))
     }
    cutdt <- setDT(as.data.frame(do.call(rbind,cutlist)))
   } else 
   {cutlist <- list()
     for (cut in pvec)
     {print(paste0('doing p (both popu) cut=',cut,' tr',trnum,' at ',Sys.time()))
     #test for reference population
     same.r <- bcdt[p.x<cut&p.y<cut&b.x*b.y>0,.N]
     ti.r <- bcdt[p.x<cut&p.y<cut,.N]
     t0.r <- 2*(ti.r-same.r)
     fdr.ed.r <- t0.r/ti.r
     fdr.r <- cut*(1- ti.r/bcdt[,.N]) / ((ti.r/bcdt[,.N])*(1-cut))
     #test for validaiton population
     same.v <- bcdt[p.x<cut&p.y<cut&b.x*b.y>0,.N]
     ti.v <- bcdt[p.x<cut&p.y<cut,.N]
     t0.v <- 2*(ti.v-same.v)
     fdr.ed.v <- t0.v/ti.v
     fdr.v <- cut*(1- ti.v/bcdt[,.N]) / ((ti.v/bcdt[,.N])*(1-cut))
     cutlist[[as.character(cut)]]<- as.numeric(c(trnum,cut,same.r,t0.r,ti.r,fdr.ed.r,fdr.r,same.v,t0.v,ti.v,fdr.ed.v,fdr.v))
     }
    cutdt <- setDT(as.data.frame(do.call(rbind,cutlist)))
   }
   cutdt[] <- lapply(cutdt, function(x) as.numeric(as.character(x))) 
   colnames(cutdt) <- c('tr','cut','same.r','t0.r','ti.r','fdr.ed.r','fdr.r','same.v','t0.v','ti.v','fdr.ed.v','fdr.v')
   cutdt[,tr:=paste0('tr',tr)]
   is.na(cutdt) <- sapply(cutdt, is.infinite)
   cutdt[,fdr.ed.r:=ifelse(fdr.ed.r>=1,1,fdr.ed.r)]
   cutdt[,fdr.r:=ifelse(fdr.r>=1,1,fdr.r)]
   cutdt[,fdr.ed.v:=ifelse(fdr.ed.v>=1,1,fdr.ed.v)]
   cutdt[,fdr.v:=ifelse(fdr.v>=1,1,fdr.v)]
   trlist[[trnum]] <- cutdt
   trbmlist[[trnum]] <- bcdt[,c(1,ncol(bcdt)),with=F]
   setkeyv(trbmlist[[trnum]],id)
   print(paste0('tr',trnum,' finished at ',Sys.time()))
 }
 trdt <- do.call(rbind,trlist)
 print(paste0('multi-trait TE analysis started at ',Sys.time()))
 trbmat <- Reduce(function(...)merge(...,all=T),trbmlist)
 trbmat[,csd.all:=rowSums(trbmat[,-1])]
 trbmat[,mt0:=2*(1-csd.all/k)]
 trbmat[,mtr:=2*csd.all/k-1]
 trbmat[,mt0:=ifelse(mt0>=1,1,mt0)]
 trbmat[,mtr:=ifelse(mtr<0,0,mtr)]
 trbmat[,trn:=round(mtr*k,0)]
 reslist <- list()
 reslist[['sfdred']] <- trdt
 reslist[['mcount']] <- trbmat[,c(1:(k+1)),with=F]
 reslist[['mfdred']] <- trbmat[,c(1,(k+2):ncol(trbmat)),with=F]
 print(paste0('analysis finished at ',Sys.time()))
 return(reslist)
}


