#conduct weighted meta-analysis from 2 populations
library(data.table)
library(qvalue)

#dlist <- dlist
#id <- 'SNP'
#chr <- 'Chr'
#bp <- 'bp'
#bpa <- 'b'
#sepa <- 'se'

w2t <- function(dlist,id,chr,bp,bpa,sepa)
{reslist <- list()
 btrc <- gsub(paste0('.',bpa),'',colnames(dlist[[1]])[grep(paste0('.',bpa),colnames(dlist[[1]]))])
ctrc <-  gsub(paste0('.',bpa),'',colnames(dlist[[2]])[grep(paste0('.',bpa),colnames(dlist[[2]]))])
#calculate weighted t
if (sum(btrc==ctrc)==length(btrc)) 
  {trbselist <- list()
   trtlist <- list()
   for (trn in as.character(btrc)) 
    {print(paste0(trn,' started at ',Sys.time()))
    bcdt <- merge(dlist[[1]][,c(which(colnames(dlist[[1]])==c(id,chr,bp)),grep(paste0(trn,'.',bpa,'|',trn,'.',sepa),colnames(dlist[[1]]))),with=F],dlist[[2]][,c(which(colnames(dlist[[2]])==c(id)),grep(paste0(trn,'.',bpa,'|',trn,'.',sepa),colnames(dlist[[2]]))),with=F],by=id,sort=F,all.x=F)
    colnames(bcdt) <- gsub(paste0(trn,'.'),'',colnames(bcdt))
    bcdt[,wb:=( ( b.x/(se.x)^2+b.y/(se.y)^2 )/( 1/(se.x)^2 + 1/(se.y)^2 ) )]
    bcdt[,wse:=sqrt( 1/( 1/(se.x)^2 + 1/(se.y)^2  ) )]
    bcdt[,tw:=wb/wse]
#get wb and wse    
   if (which(btrc==trn)<=1)
      {trbselist[[trn]] <- bcdt[,c(which(colnames(bcdt) %in% c(id,chr,bp)),ncol(bcdt)-2,ncol(bcdt)-1),with=F]
      } else
      {trbselist[[trn]] <- bcdt[,c(ncol(bcdt)-2,ncol(bcdt)-1),with=F]
      }
#get wt
      if (which(btrc==trn)<=1)
      {trtlist[[trn]] <- bcdt[,c(which(colnames(bcdt) %in% c(id,chr,bp)),ncol(bcdt)),with=F]
      } else
      {trtlist[[trn]] <- bcdt[,ncol(bcdt),with=F]
      }
     }
   reslist[['bcwbse']] <- do.call(cbind,trbselist)
   colnames(reslist[['bcwbse']])[1:3] <- c(id,chr,bp)
   reslist[['bcwt']] <- do.call(cbind,trtlist) 
   colnames(reslist[['bcwt']])[1:3] <- c(id,chr,bp) 
   return(reslist) } else 
   print(paste0('weight t calculation finished at ',Sys.time()))
   {print('Error: trait names of two populations dont match')
   }
}


